/***************************************************************************
                          world.h  -  description
                             -------------------
    begin                : Sun Sep 15 2002
    copyright            : (C) 2002 by Michal Ramsza
    email                : mramsz@sgh.waw.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include "agent.h"


class world {
private:
  FILE * config_file; // ini file
  FILE * data_file; // file with output data
  FILE * desc_file; // descriptions

  char G_DataFile[200]; /* path to output data file */
  char G_DescFile[200]; /* path to output data file */
  float G_IniProb; // initial probability to choose first action
  int G_NumOfAgents; // number of agents
  int G_NumOfSteps; // number of steps
  float G_SamplingProbability; // probability of triggering sampling procedure
  int G_SamplingLength; // number of samples per action
  int G_Step; // frequency of data output
  float Payoff[2][2]; // matrix of payoffs "there is no spoon" ;)
  int S_Active;
  int S_ActionActive;
  int S_Passive;
  int S_ActionPassive;
  int S_AverageWealth;
  agent *A; // system of agents
  int time;

public:
  int step(void); // moving the system forward
  int prereport(void);
  int report(void); // sending data to a file

  world(); // reading ini file, creating system, opening data file
  ~world(); // removing system, closing data file
};


